// AO40RcvView.cpp : implementation of the CAO40RcvView class
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AO40Rcv.h"

#include "MainFrm.h"
#include "AO40RcvDoc.h"
#include "AO40RcvView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define VIEWTOGGLETIME 15

/////////////////////////////////////////////////////////////////////////////
// CAO40RcvView

IMPLEMENT_DYNCREATE(CAO40RcvView, CResizableFormView)

BEGIN_MESSAGE_MAP(CAO40RcvView, CResizableFormView)
	//{{AFX_MSG_MAP(CAO40RcvView)
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab)
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(IDM_CLEARDATA, OnCleardata)
	ON_BN_CLICKED(IDC_AFCON, OnAfcon)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_BN_CLICKED(IDC_STARTSTOP, OnStartstop)
	ON_BN_CLICKED(IDC_LEFTBUTTON, OnLeftbutton)
	ON_BN_CLICKED(IDC_RIGHTBUTTON, OnRightbutton)
	ON_BN_CLICKED(IDC_WAVEPAUSE, OnWavepause)
	ON_BN_CLICKED(IDC_DOPDN, OnDopdn)
	ON_BN_CLICKED(IDC_DOPUP, OnDopup)
	ON_NOTIFY(UDN_DELTAPOS, IDC_BITADJSPIN, OnDeltaposBitadjspin)
	ON_BN_CLICKED(IDC_ZEROSNRBUTTON, OnZerosnrbutton)
	ON_WM_SIZE()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
	ON_MESSAGE( MSG_FFTDATARDY, OnFFTDataRdy)
	ON_MESSAGE( MSG_DATARDY, OnDataRdy)
	ON_MESSAGE( MSG_STATUSCHANGE, OnStatusChange)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAO40RcvView construction/destruction

CAO40RcvView::CAO40RcvView()
	: CResizableFormView(CAO40RcvView::IDD)
{
	//{{AFX_DATA_INIT(CAO40RcvView)
	m_AFCOn = FALSE;
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_pCPlotData = NULL;
	m_RxFreq = 1600;
	m_ProgCounter = 0;
	m_AFCOn = TRUE;
	m_LastNetStatus = -1;
}

CAO40RcvView::~CAO40RcvView()
{
}

void CAO40RcvView::DoDataExchange(CDataExchange* pDX)
{
	CResizableFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAO40RcvView)
	DDX_Control(pDX, IDC_CURFREQTXT, m_CurFreqTxtCtrl);
	DDX_Control(pDX, IDC_FECERRORSTXT, m_FECErrorTxtCtrl);
	DDX_Control(pDX, IDC_FECSTATTXT, m_FECStatTxtCtrl);
	DDX_Control(pDX, IDC_CRCSTATTXT, m_CRCStatTxtCtrl);
	DDX_Control(pDX, IDC_BITADJTXT, m_BitAdjTxtCtrl);
	DDX_Control(pDX, IDC_SNRSTATUS, m_SNRCtrl);
	DDX_Control(pDX, IDC_DOPCORRTXT, m_DopplerCorrCtrl);
	DDX_Control(pDX, IDC_DOPUP, m_DopplerUpCtrl);
	DDX_Control(pDX, IDC_DOPDN, m_DopplerDnCtrl);
	DDX_Control(pDX, IDC_DOPFREQTXT, m_DopFreqCtrl);
	DDX_Control(pDX, IDC_WAVEPAUSE, m_WavePauseCtrl);
	DDX_Control(pDX, IDC_RIGHTBUTTON, m_RightCtrl);
	DDX_Control(pDX, IDC_LEFTBUTTON, m_LeftCtrl);
	DDX_Control(pDX, IDC_STARTSTOP, m_StartStopCtrl);
	DDX_Control(pDX, IDC_NETSTATUS, m_NetStatusCtrl);
	DDX_Control(pDX, IDC_FILESTATUS, m_FileStatusCtrl);
	DDX_Control(pDX, IDC_LASTBLKSTATUS, m_BlkCountCtrl);
	DDX_Control(pDX, IDC_FREQTXT, m_FreqTxtCntrl);
	DDX_Control(pDX, IDC_TAB1, m_TabCtrl);
	DDX_Check(pDX, IDC_AFCON, m_AFCOn);
	//}}AFX_DATA_MAP
  	DDX_Control(pDX, IDC_PROGRESSCRC, m_CRCProgCtrl);
  	DDX_Control(pDX, IDC_PROGRESSFEC, m_FECProgCtrl);
	DDX_Control(pDX, IDC_TEXTRICHEDIT, m_RxTextCtrl);
	
	DDX_Control(pDX, IDC_DEBUG3, m_DebugCtrl3);
	DDX_Control(pDX, IDC_DEBUG2, m_DebugCtrl2);
	DDX_Control(pDX, IDC_DEBUG1, m_DebugCtrl1);
}

BOOL CAO40RcvView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CResizableFormView::PreCreateWindow(cs);
}
/////////////////////////////////////////////////////////////////////////////
// CAO40RcvView diagnostics

#ifdef _DEBUG
void CAO40RcvView::AssertValid() const
{
	CResizableFormView::AssertValid();
}

void CAO40RcvView::Dump(CDumpContext& dc) const
{
	CResizableFormView::Dump(dc);
}

CAO40RcvDoc* CAO40RcvView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAO40RcvDoc)));
	return (CAO40RcvDoc*)m_pDocument;
}
#endif //_DEBUG

////////////////////////////////////////////////////////////////////////
//   Initialize the main view state and variables
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnInitialUpdate()
{
INT err = 0;
CWnd* pWnd;
CRect cr;
CString str;
CAO40RcvDoc* pDoc = GetDocument();
	if(!m_pCPlotData)
	{
		//instantiate display data plotting and processing  objects
		// ***** must add controls to the layout  ****
		// before OnInitialUpdate base implementation
		AddAnchor(IDC_TAB1, TOP_LEFT, BOTTOM_RIGHT);
		AddAnchor(IDC_PLOTRECT, TOP_LEFT, BOTTOM_RIGHT);


		AddAnchor(IDC_PROGRESSCRC, BOTTOM_LEFT, NOANCHOR);
		AddAnchor(IDC_PROGRESSFEC, BOTTOM_LEFT, NOANCHOR);
		AddAnchor(IDC_STARTSTOP, BOTTOM_LEFT, NOANCHOR);
		AddAnchor(IDC_LEFTBUTTON, BOTTOM_LEFT, NOANCHOR);
		AddAnchor(IDC_RIGHTBUTTON, BOTTOM_LEFT, NOANCHOR);
		AddAnchor(IDC_WAVEPAUSE, BOTTOM_LEFT, NOANCHOR);
		AddAnchor(IDC_FECERRORSTXT, BOTTOM_LEFT, NOANCHOR);
		AddAnchor(IDC_LASTBLKSTATUS, BOTTOM_LEFT, NOANCHOR);
		AddAnchor(IDC_FECSTATTXT, BOTTOM_LEFT, NOANCHOR);
		AddAnchor(IDC_CRCSTATTXT, BOTTOM_LEFT, NOANCHOR);

		AddAnchor(IDC_NETSTATUS, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_FILESTATUS, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_FREQTXT, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_DOPFREQTXT, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_DOPCORRTXT, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_DOPCORTITLE, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_DOPDN, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_DOPUP, BOTTOM_CENTER, NOANCHOR);
		
		AddAnchor(IDC_TEXTRICHEDIT, BOTTOM_CENTER, NOANCHOR);

		AddAnchor(IDC_BITADJSPIN, BOTTOM_RIGHT, NOANCHOR);
		AddAnchor(IDC_SNRSTATUS, BOTTOM_RIGHT, NOANCHOR);
		AddAnchor(IDC_SNRLABLETXT, BOTTOM_RIGHT, NOANCHOR);
		AddAnchor(IDC_ZEROSNRBUTTON, BOTTOM_RIGHT, NOANCHOR);
		AddAnchor(IDC_DEBUG1, BOTTOM_RIGHT, NOANCHOR);
		AddAnchor(IDC_DEBUG2, BOTTOM_RIGHT, NOANCHOR);
		AddAnchor(IDC_DEBUG3, BOTTOM_RIGHT, NOANCHOR);
		AddAnchor(IDC_AFCON, BOTTOM_RIGHT, NOANCHOR);
		AddAnchor(IDC_BITADJTXT, BOTTOM_RIGHT, NOANCHOR);
		AddAnchor(IDC_BITLBLTXT, BOTTOM_RIGHT, NOANCHOR);
		AddAnchor(IDC_CURFREQTXT, BOTTOM_RIGHT, NOANCHOR);

		m_pCPlotData = new CPlotData();	//initialize Data plotting resources
		ASSERT(m_pCPlotData);
		CResizableFormView::OnInitialUpdate();
	}
	else
	{
		CResizableFormView::OnInitialUpdate();
	}
	pWnd = GetDlgItem( IDC_PLOTRECT );
	ASSERT_VALID( pWnd);
	pWnd->GetWindowRect( m_FrameRect );
	ScreenToClient( &m_FrameRect );
	m_LastRect = m_FrameRect;

	// See if need to Keep program "ON Top" of all others.
	CMainFrame* pFrm=(CMainFrame*)AfxGetMainWnd();
	pFrm->StayOnTop();	

	m_CRCProgCtrl.SetValue( 0 );
	m_CRCProgCtrl.SetProgressState(PROG_STATE_OFF,"Off");

	m_FECProgCtrl.SetValue( 0 );
	m_FECProgCtrl.SetProgressState(PROG_STATE_OFF,"Off");

	str = _T("AO40Rcv - Ver. 2.04 - ") + pDoc->m_CallSign;
	AfxGetMainWnd()->SetWindowText( str );

	m_NetStatusCtrl.SetWindowText("");
	m_FileStatusCtrl.SetWindowText("");
//  Add plot display TAB control initialization here
	TC_ITEM tci;
	tci.mask = TCIF_TEXT;
	str = _T("Signal-F1");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_TabCtrl.InsertItem(TAB_SIG_VIEW0, &tci);
	str = _T("Status-F2");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_TabCtrl.InsertItem(TAB_STAT_VIEW1, &tci);
	str = _T("IF Matrix-F3");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_TabCtrl.InsertItem(TAB_MATRIX_VIEW2, &tci);
	str = _T("Navigation-F4");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_TabCtrl.InsertItem(TAB_NAV_VIEW3, &tci);
	str = _T("Power-F5");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_TabCtrl.InsertItem(TAB_PWR_VIEW4, &tci);
	str = _T("Temperature-F6");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_TabCtrl.InsertItem(TAB_TEMP_VIEW5, &tci);
	str = _T("Mailbox-F7");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_TabCtrl.InsertItem(TAB_MAIL_VIEW6, &tci);
	str = _T("Raw Data-F8");
	tci.pszText = (LPSTR)(LPCTSTR)str;
	tci.cchTextMax = str.GetLength();
	m_TabCtrl.InsertItem(TAB_RAW_VIEW7, &tci);

	m_TabCtrl.SetCurSel(pDoc->m_PlotType);
	m_RxTextCtrl.SetCharFormat( pDoc->m_lfRcvFont,
								pDoc->m_crRcvTextColor,
								pDoc->m_crRcvBackColor	);
	m_RxTextCtrl.ClearAll();
	m_RxTextCtrl.SetText( pDoc->GetOutputText() );
	if(pDoc->m_PlotType != TAB_SIG_VIEW0)
	{
		m_DispFreeze = TRUE;
		m_RxTextCtrl.EnableWindow(TRUE);
	}
	else
	{
		m_DispFreeze = FALSE;
		m_RxTextCtrl.EnableWindow(FALSE);
	}
	m_LastTab = pDoc->m_PlotType;
	m_BlksOK = 0;
	m_FECBlksOK = 0;
	m_BlksReceived = 0;
	m_FECBlksReceived = 0;
	m_FECProgCounter = 0;
	m_WaveLogPaused = FALSE;
	m_AutoViewTimer = VIEWTOGGLETIME;

	m_Str.Format("%d",pDoc->m_BitAdjust);
	m_BitAdjTxtCtrl.SetWindowText(m_Str);

	SetButtonTypes();
	InitTlmRead();
	fnSetCmdStrings(pDoc->m_UPString,pDoc->m_DNString);
	m_DopplerCorrection = 0;
	SetDopplerCorrection(0);
	SetDopplerMode(pDoc);
	if(pDoc->m_InGroup == INPUT_SOUND && !pDoc->m_UseWaveOut)
		Start();
	else
		Stop();

	fnZeroSNR( (double)pDoc->m_SNRFilterFactor);
	fnSetBitAdj(pDoc->m_BitAdjust);
	UpdateData(FALSE);
}

////////////////////////////////////////////////////////////////////////
//  Called to clean up before exiting
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnDestroy() 
{
	fnStopReceive();
	if(m_pCPlotData)
	{
		delete m_pCPlotData;
		m_pCPlotData = NULL;
	}
	CResizableFormView::OnDestroy();
}

////////////////////////////////////////////////////////////////////////
//  Called by system to redraw the screens if something changed
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnDraw(CDC* pDC) 
{
CAO40RcvDoc* pDoc = (CAO40RcvDoc*)GetDocument();
CWnd* pWnd = GetParent();
	//go recalculate & draw the data plots
	if(m_pCPlotData  && !pWnd->IsIconic() )
	{
		pWnd = GetDlgItem( IDC_PLOTRECT );
		ASSERT_VALID( pWnd);
		pWnd->GetWindowRect( m_FrameRect );
		ScreenToClient( &m_FrameRect );
		m_pCPlotData->OnDrawPlot( m_hWnd, m_FrameRect, pDoc );
		if(	m_LastRect != m_FrameRect)
		{
			m_LastRect = m_FrameRect;
			NewFrameSize(m_FrameRect);
		}
	}
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  C A O 4 0 R c v V i e w    M e s s a g e     H a n d l e r s
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

////////////////////////////////////////////////////////////////////////
//   Called when DLL has a new block of FFT data ready
////////////////////////////////////////////////////////////////////////
afx_msg LRESULT CAO40RcvView::OnFFTDataRdy(UINT x, LONG y)
{
CAO40RcvDoc* pDoc = GetDocument();
CString str;
	ASSERT_VALID( pDoc );
/////////////////debug output
//double debug1;
//double debug2;
//INT debug3 = fnGetDebugData( &debug1,&debug2);
//	str.Format("%g",debug1);
//	m_DebugCtrl1.SetWindowText(str);
//	str.Format("%g",debug2);
//	m_DebugCtrl2.SetWindowText(str);
//	str.Format("%d",debug3);
//	m_DebugCtrl3.SetWindowText(str);
/////////////////debug output
	if(pDoc->m_AutoViewToggle)
	{
		if(m_AutoViewTimer-- <= 0 )
		{
			SetTABExternal(TAB_SIG_VIEW0);
		}
	}
	str.Format(_T("%4.3g dB"),(double)y/10.0);
	m_SNRCtrl.SetWindowText( str);

	fnGetRXFrequency( (long*)&m_RxFreq, &pDoc->m_DopplerShift);
	str.Format(_T("%d Hz"),m_RxFreq);
	m_FreqTxtCntrl.SetWindowText( str);
	str.Format(_T("%+4.2g Hz/Sec"),(double)((int)(10*pDoc->m_DopplerShift))/10.);
	m_DopFreqCtrl.SetWindowText( str);
	if(	(pDoc->m_RecvState == STATE_SYNC) || (pDoc->m_RecvState == STATE_READ) )
		pDoc->SendNetworkFreq(m_RxFreq);
	else
		pDoc->SendNetworkFreq(0);
	if(pDoc->m_InGroup == INPUT_WAVE )
	{
		if( x > 98 )
			x = 100;
		str.Format("%d%% Complete",x);
	}
	else
	{
		if( pDoc->m_RigModeGroup == (RIGCTRL_MODE_PROPORTIONAL | RIGCTRL_MODE_ACTIVEMASK) )
		{
			m_DopplerCorrection = fnGetDopCorrectionRate();
			str.Format("%+d Hz/S",m_DopplerCorrection);
			m_DopplerCorrCtrl.SetWindowText(str);
		}
		if( pDoc->m_UseWaveOut)
			str.Format("Disk %d%% Full",x);
		else
			str = "";
	}
	m_FileStatusCtrl.SetWindowText(str);
	//go draw the data plots
	CWnd* pWnd = GetParent();
	if(m_pCPlotData  && !m_DispFreeze && !pWnd->IsIconic())
	{
		m_pCPlotData->SetCursFreq(m_RxFreq);
		m_pCPlotData->DrawPlot();
	}
	if( pDoc->m_RecvState == STATE_READ)
	{
		m_CRCProgCtrl.SetValue( ++m_ProgCounter );
		m_CRCProgCtrl.SetProgressState(PROG_STATE_READ,"Reading CRC Block");
	}
	else
	{
		if( (m_Status & DLLSTAT_RXFEC_MASK ) == DLLSTAT_RXFEC_SYNC_SEARCH )
		{
			m_FECProgCtrl.SetValue( ++m_FECProgCounter );
		}
	}
	return 0;
}

////////////////////////////////////////////////////////////////////////
//  Called when DLL has a new data block ready
////////////////////////////////////////////////////////////////////////
afx_msg LRESULT CAO40RcvView::OnDataRdy(UINT FECErrors, LONG blocktype)
{
char pData[514];
BOOL crcok;
CAO40RcvDoc* pDoc = GetDocument();
CString str;
	ASSERT_VALID( pDoc );
	crcok = fnGetDataBlock( pData );	//check block for CRC error

	if(blocktype==FECBLOCK)
	{
		m_FECProgCounter = 0;
		m_FECProgCtrl.SetValue( 1 );
		m_FECBlksReceived++;
		m_FECProgCtrl.SetProgressState(PROG_STATE_READ,"");
		if(crcok)
		{
			m_FECBlksOK++;
			pDoc->m_RecvState = STATE_FECOK;
			m_FECProgCtrl.SetProgressState(PROG_STATE_GOOD,"FEC Block OK");
		}
		else
		{
			pDoc->m_RecvState = STATE_FECBAD;
			m_FECProgCtrl.SetProgressState(PROG_STATE_BAD,"FEC Block Bad");
		}
		str.Format(_T("%d/%d"),	m_FECBlksOK, m_FECBlksReceived);
		m_FECStatTxtCtrl.SetWindowText( str);
	}
	else	//is regular CRC block
	{
		m_BlksReceived++;
		if(crcok)
		{
			m_BlksOK++;
			pDoc->m_RecvState = STATE_CRCOK;
			m_CRCProgCtrl.SetProgressState(PROG_STATE_GOOD,"CRC Block OK");
		}
		else
		{
			pDoc->m_RecvState = STATE_CRCBAD;
			m_CRCProgCtrl.SetProgressState(PROG_STATE_BAD,"CRC Block Bad");
		}
		str.Format(_T("%d/%d"),	m_BlksOK, m_BlksReceived);
		m_CRCStatTxtCtrl.SetWindowText( str);
	}

	int total = m_BlksReceived+m_FECBlksReceived;
//	if( total !=0)
	{
		str.Format(_T("%d/%d"), m_BlksOK+m_FECBlksOK, total);
		m_BlkCountCtrl.SetWindowText( str );
	}
	if(m_FECBlksReceived>0 )
	{
		str.Format(_T("Corrected symbols / bytes = %d / %d"), FECErrors&0xFFFF, FECErrors>>16);
		m_FECErrorTxtCtrl.SetWindowText(str);
	}
	if(pDoc->DecodeBlock( pData,crcok ))
	{
		pDoc->m_RawLogOn= FALSE;
		pDoc->m_TlmLogOn= FALSE;
	}
	if(pDoc->m_AutoViewToggle)
	{
		SetTABExternal(TAB_STAT_VIEW1);
		m_AutoViewTimer = VIEWTOGGLETIME;
	}
	else
	{
		if(pDoc->m_PlotType != TAB_SIG_VIEW0)
		{
			m_RxTextCtrl.ClearAll();
			m_RxTextCtrl.SetText( pDoc->GetOutputText() );
		}
	}
	return 0;
}

////////////////////////////////////////////////////////////////////////
//   Called when DLL has changed status or is an error
////////////////////////////////////////////////////////////////////////
afx_msg LRESULT CAO40RcvView::OnStatusChange(UINT status, LONG y)
{
CAO40RcvDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	if(	pDoc->m_RecvState == STATE_STOPPED )
		return 0;
	m_Status = status;
	switch( status & DLLSTAT_RXCRC_MASK )
	{
		case DLLSTAT_RXCRC_NO_SIGNAL:
			m_CRCProgCtrl.SetValue( 0 );
			m_CRCProgCtrl.SetProgressState(PROG_STATE_NOSIG,"No CRC Signal");
			m_ProgCounter = 0;
			break;
		case DLLSTAT_RXCRC_SYNC_SEARCH:
			m_ProgCounter = 0;
			m_FECProgCounter = 0;
			m_FECProgCtrl.SetValue( 1 );
			pDoc->m_RecvState = STATE_SYNC;
			m_CRCProgCtrl.SetValue( 1 );
			m_CRCProgCtrl.SetProgressState(PROG_STATE_SYNC,"Searching for CRC Sync");
			break;
		case DLLSTAT_RXCRC_BLOCK_READ:
			pDoc->m_RecvState = STATE_READ;
			m_CRCProgCtrl.SetValue( m_ProgCounter );
			m_CRCProgCtrl.SetProgressState(PROG_STATE_READ,"Reading CRC Block");
			break;
		case DLLSTAT_CPUSLOW:
			pDoc->m_RecvState = STATE_TOOSLOW;
			break;
		case DLLSTAT_WAVEFINISHED:
		default:
			Stop();
			m_CRCProgCtrl.SetValue( 0 );
			m_FECProgCtrl.SetValue( 0 );
			break;
	}
	if(	pDoc->m_RecvState == STATE_STOPPED )
		return 0;
	switch( status & DLLSTAT_RXFEC_MASK )
	{
		case DLLSTAT_RXFEC_NO_SIGNAL:
			m_FECProgCounter = 1;
			m_FECProgCtrl.SetValue( 0 );
			m_FECProgCtrl.SetProgressState(PROG_STATE_NOSIG,"No FEC Signal");
			m_FECErrorTxtCtrl.SetWindowText("");
			break;
		case DLLSTAT_RXFEC_SYNC_SEARCH:
			m_FECProgCtrl.SetValue( m_FECProgCounter );
			m_FECProgCtrl.SetProgressState(PROG_STATE_FECSYNC,"Searching for FEC Block");
			break;
		case DLLSTAT_RXFEC_BLOCK_READ:
//			m_FECProgCtrl.SetValue( 10 );
//			m_FECProgCtrl.SetProgressState(PROG_STATE_READ,"Reading FEC Block");
			break;
		default:
			break;
	}
	if( status == (DLLSTAT_RXCRC_MASK||DLLSTAT_RXFEC_MASK) )
		pDoc->m_RecvState = STATE_NOSIG;
	if( (status == DLLSTAT_RXCRC_SYNC_SEARCH) ||
				(status == DLLSTAT_RXFEC_SYNC_SEARCH) )
		pDoc->m_RecvState = STATE_SYNC;
	return 0;
}

////////////////////////////////////////////////////////////////////////
//  Called when mouse left button is pressed once to change frequency
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnLButtonDown(UINT nFlags, CPoint point) 
{
CWnd* pWnd;
	if( m_pCPlotData->CurInFreqPlot(point) )
	{
		INT freq = m_pCPlotData->GetCursFreq( point );
		m_RxFreq = freq;
		fnSetRXFrequency(m_RxFreq);
	}
	else
	{
		CRect rect;
		pWnd = GetDlgItem( IDC_DOPCORRTXT ); ASSERT_VALID(pWnd);
		pWnd->GetWindowRect( &rect );
		ScreenToClient(&rect);
		if(	rect.PtInRect(point) )	//clr doppler correction if click in
		{							//control
			SetDopplerCorrection( 0 );
		}
	}
	CResizableFormView::OnLButtonDown(nFlags, point);
}

////////////////////////////////////////////////////////////////////////
//  Called when user clicks on one of the TAB selections to change the view
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnSelchangeTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
CAO40RcvDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	pDoc->m_PlotType = m_TabCtrl.GetCurSel();
	if(pDoc->m_PlotType != TAB_SIG_VIEW0)
	{
		m_RxTextCtrl.EnableWindow(TRUE);
		m_DispFreeze = TRUE;
		m_RxTextCtrl.ClearAll();
		m_RxTextCtrl.SetText( pDoc->GetOutputText() );
	}
	else
	{
		m_DispFreeze = FALSE;
		m_RxTextCtrl.EnableWindow(FALSE);
	}
	Invalidate();
	m_LastTab = pDoc->m_PlotType;
	*pResult = 0;
}


////////////////////////////////////////////////////////////////////////
//  Called when user clicks on the Start/Stop button
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnStartstop() 
{
CAO40RcvDoc* pDoc = GetDocument();
	if(	pDoc->m_RecvState == STATE_STOPPED )
		Start();
	else
		Stop();
}

////////////////////////////////////////////////////////////////////////
//  Called when user clicks on Clear Screens menu item
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnCleardata() 
{
CAO40RcvDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	pDoc->ClearScreens();
	m_RxTextCtrl.ClearAll();
}


////////////////////////////////////////////////////////////////////////
//  Called when user changes state of AFC checkbox
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnAfcon() 
{
	UpdateData(TRUE);
	fnSetRxMode( m_AFCOn );	
}


////////////////////////////////////////////////////////////////////////
//  Called when user copies text into clipboard
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnEditCopy() 
{
	m_RxTextCtrl.CopyClip();
}


////////////////////////////////////////////////////////////////////////
//  Called to init the telemetry file read data
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::InitTlmRead()
{
CAO40RcvDoc* pDoc = GetDocument();
CString str = "";
	if((pDoc->m_InGroup == INPUT_RAW) && (pDoc->m_NumBlocksInFile > 0) )
	{
		if( pDoc->m_BlkOffset < 0 )
			pDoc->m_BlkOffset = 0;
		if( pDoc->m_BlkOffset >= pDoc->m_NumBlocksInFile )
			pDoc->m_BlkOffset = pDoc->m_NumBlocksInFile-1;
		str.Format(_T("Block %d of %d"),pDoc->m_BlkOffset+1,pDoc->m_NumBlocksInFile);
		m_BlkCountCtrl.SetWindowText( str );
		if(pDoc->m_PlotType != TAB_SIG_VIEW0)
		{
			if(pDoc->ReadRawFile())
				AfxMessageBox( _T("Error Reading Data File") );
			else
			{
				m_RxTextCtrl.ClearAll();
				m_RxTextCtrl.SetText( pDoc->GetOutputText() );
			}
		}
	}
	m_BlkCountCtrl.SetWindowText( str );
}

////////////////////////////////////////////////////////////////////////
//  Called when user clicks to display previous data block
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnLeftbutton() 
{
CAO40RcvDoc* pDoc = GetDocument();
CString str;
	if((pDoc->m_InGroup == INPUT_RAW) && (pDoc->m_NumBlocksInFile > 0) )
	{
		if(pDoc->m_PlotType != TAB_SIG_VIEW0)
		{
			pDoc->m_BlkOffset--;
			if( pDoc->m_BlkOffset >= 0 )
			{
				if(pDoc->ReadRawFile())
					AfxMessageBox( _T("Error Reading raw File") );
				else
				{
					m_RxTextCtrl.ClearAll();
					m_RxTextCtrl.SetText( pDoc->GetOutputText() );
					str.Format(_T("Block %d of %d"),pDoc->m_BlkOffset+1,pDoc->m_NumBlocksInFile);
					m_BlkCountCtrl.SetWindowText( str );
				}
			}
			else
			{
				pDoc->m_BlkOffset = 0;
			}
		}
	}
}


////////////////////////////////////////////////////////////////////////
//  Called when user clicks to display next data block
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnRightbutton() 
{
CAO40RcvDoc* pDoc = GetDocument();
CString str;
	if((pDoc->m_InGroup == INPUT_RAW) && (pDoc->m_NumBlocksInFile > 0) )
	{
		if(pDoc->m_PlotType != TAB_SIG_VIEW0)
		{
			pDoc->m_BlkOffset++;
			if( pDoc->m_BlkOffset < pDoc->m_NumBlocksInFile )
			{
				if(pDoc->ReadRawFile())
					AfxMessageBox( _T("Error Reading raw File") );
				else
				{
					m_RxTextCtrl.ClearAll();
					m_RxTextCtrl.SetText( pDoc->GetOutputText() );
					str.Format(_T("Block %d of %d"),pDoc->m_BlkOffset+1,pDoc->m_NumBlocksInFile);
					m_BlkCountCtrl.SetWindowText( str );
				}
			}
			else
			{
				pDoc->m_BlkOffset = pDoc->m_NumBlocksInFile-1;
			}
		}
	}
}

////////////////////////////////////////////////////////////////////////
//  Called when user clicks .wav log file pause/resume button
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnWavepause() 
{
CAO40RcvDoc* pDoc = GetDocument();
	if(m_WaveLogPaused)
	{
		m_WaveLogPaused = FALSE;
		m_WavePauseCtrl.SetWindowText( _T("Capture On") );
	}
	else
	{
		m_WaveLogPaused = TRUE;
		m_WavePauseCtrl.SetWindowText( _T("Capture Paused") );
	}
	fnPauseOutWave(m_WaveLogPaused);
}
////////////////////////////////////////////////////////////////////////
//   Called when The Doppler correction dn button is pushed
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnDopdn() 
{
	SetDopplerCorrection( m_DopplerCorrection - 1);
}

////////////////////////////////////////////////////////////////////////
//   Called when The Doppler correction up button is pushed
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::OnDopup() 
{
	SetDopplerCorrection( m_DopplerCorrection + 1);
}

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//               H e l p e r    F u n c t i o n s
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

////////////////////////////////////////////////////////////////////////
//  Called to figure out how to display the wave logging pause/resume button
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::CheckWavePause()
{
CAO40RcvDoc* pDoc = GetDocument();
	if( (pDoc->m_InGroup == INPUT_SOUND ) && pDoc->m_UseWaveOut )
	{
		m_WavePauseCtrl.ShowWindow( SW_SHOW );
		if(m_WaveLogPaused)
			m_WavePauseCtrl.SetWindowText( _T("Capture Paused") );
		else
			m_WavePauseCtrl.SetWindowText( _T("Capture On") );
		fnPauseOutWave(m_WaveLogPaused);
	}
	else
	{
		m_WavePauseCtrl.ShowWindow( SW_HIDE );
		m_WaveLogPaused = FALSE;
	}
}

////////////////////////////////////////////////////////////////////////
//  Called from CMainFrm to recalculate the TAB view screen size/position
//   if frame changes size
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::NewFrameSize(CRect cr)
{
CAO40RcvDoc* pDoc = GetDocument();
	if(m_pCPlotData)
	{
		m_RxTextCtrl.MoveWindow(&m_FrameRect,TRUE);
		if(pDoc->m_PlotType != TAB_SIG_VIEW0)
		{
			m_RxTextCtrl.ClearAll();
			m_RxTextCtrl.SetText( pDoc->GetOutputText() );
		}
		m_pCPlotData->ClearBufs();
	}
}

////////////////////////////////////////////////////////////////////////
//  Called to figure out which buttons should be visable and their state
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::SetButtonTypes()
{
CAO40RcvDoc* pDoc = GetDocument();
	switch(pDoc->m_InGroup)
	{
		case INPUT_SOUND:
		case INPUT_WAVE:
			m_StartStopCtrl.ShowWindow( SW_SHOW );
			m_LeftCtrl.ShowWindow( SW_HIDE );
			m_RightCtrl.ShowWindow( SW_HIDE );
			break;
		case INPUT_RAW:
			m_LeftCtrl.ShowWindow( SW_SHOW );
			m_RightCtrl.ShowWindow( SW_SHOW );
			m_StartStopCtrl.ShowWindow( SW_HIDE );
			break;
	}
	CheckWavePause();
}

////////////////////////////////////////////////////////////////////////
//  Called to start either the soundcard or wavefile audio DLL process
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::Start() 
{
INT error = 0;
char estr[80];
CAO40RcvDoc* pDoc = GetDocument();
	if(pDoc->m_InGroup == INPUT_RAW)
		return;
	m_BlksOK = 0;
	m_FECBlksOK = 0;
	m_BlksReceived = 0;
	m_FECBlksReceived = 0;
	if(pDoc->m_PlotType == TAB_SIG_VIEW0)
		m_DispFreeze = FALSE;
	else
		m_DispFreeze = TRUE;
	switch(pDoc->m_InGroup)
	{
		case INPUT_SOUND:
			if(pDoc->m_UseWaveOut)
			{
				CString str = pDoc->m_OutWavePath;
				if(pDoc->m_UseTimeStamp)
				{
					CTime time = CTime::GetCurrentTime();
					str.Replace( ".wav", time.Format(_T("_%y%m%d_%H%M%S.wav")) );
				}
				INT filesize = fnSetOutWavePath( str, pDoc->m_WaveAppend );
				if( filesize <= 0)
					pDoc->m_UseWaveOut = FALSE;
			}
			error =	fnStartSoundReceive( m_hWnd,pDoc->m_SoundCard,pDoc->m_UseWaveOut, m_AFCOn);
			SetDopplerMode(pDoc);
			break;
		case INPUT_WAVE:
			error = fnStartWaveReceive( m_hWnd, (LPCTSTR)pDoc->m_InWavePath,
											m_AFCOn, pDoc->m_WaveStartOffset );
			break;
		default:
			break;
	}
	if(error)
	{
		pDoc->m_RecvState = STATE_STOPPED;
		fnGetErrorString( estr);
		AfxMessageBox( estr );
	}
	else		// here if everything is cool
	{
		pDoc->m_RecvState = STATE_NOSIG;
		CheckWavePause();
		m_StartStopCtrl.SetIcon( AfxGetApp()->LoadIcon(IDI_STOP) );
		m_FECStatTxtCtrl.SetWindowText("");
		m_CRCStatTxtCtrl.SetWindowText("");
		m_FECErrorTxtCtrl.SetWindowText("");
		m_BlkCountCtrl.SetWindowText("");
	}
}

////////////////////////////////////////////////////////////////////////
//  Called to Stop the DLL soundcard or wavefile audio processing
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::Stop() 
{
CAO40RcvDoc* pDoc = GetDocument();
	m_DispFreeze = TRUE;
	m_StartStopCtrl.SetIcon( AfxGetApp()->LoadIcon(IDI_START) );
	fnStopReceive();
	pDoc->m_RecvState = STATE_STOPPED;
	Sleep(50);
	m_CRCProgCtrl.SetProgressState(STATE_STOPPED, "Off");
	m_FECProgCtrl.SetProgressState(PROG_STATE_OFF,"Off");
	m_FileStatusCtrl.SetWindowText(_T(""));
	CheckWavePause();
}

////////////////////////////////////////////////////////////////////////
//  Called from CMainFrm to stop process due to menu changes
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::StopProcess()
{
CAO40RcvDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	Stop();
	pDoc->ClearScreens();
	m_RxTextCtrl.ClearAll();
	if(pDoc->m_PlotType == TAB_SIG_VIEW0)
		m_pCPlotData->RedrawScreen();
}
////////////////////////////////////////////////////////////////////////
//  Called from CMainFrm to update the network status
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::UpdateNetStatus(CAO40RcvDoc* pDoc)
{
CString str;
	if(	(pDoc->m_NetStatus != m_LastNetStatus) || 
						(m_LastNetStatus == NET_SEND) )
	{
		m_LastNetStatus = pDoc->m_NetStatus;
		switch(m_LastNetStatus)
		{
			case NET_OFF:
				str = "";
				break;
			case NET_LISTENING:
				str = "Net Listening";
				break;
			case NET_CONNECTED:
				str = "Client " + pDoc->m_ConnectedPeer;
				break;
			case NET_SEND:
				str = "Net Sent Blk";
				pDoc->m_NetStatus = NET_CONNECTED;
				break;
			case NET_ERROR:
				str = "Net Error";
				break;
		}
		m_NetStatusCtrl.SetWindowText(str);
	}
}


////////////////////////////////////////////////////////////////////////
//   Called to set the operating parameters for the doppler correction
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::SetDopplerMode(CAO40RcvDoc* pDoc)
{
CWnd* pWnd;
	pWnd = GetDlgItem( IDC_DOPCORTITLE ); ASSERT_VALID(pWnd);
	if( (pDoc->m_RigModeGroup & RIGCTRL_MODE_ACTIVEMASK) &&
				( pDoc->m_InGroup == INPUT_SOUND) )
	{
		switch( (pDoc->m_RigModeGroup & ~RIGCTRL_MODE_ACTIVEMASK) )
		{
			case RIGCTRL_MODE_MANUAL:
				m_DopplerCorrCtrl.ShowWindow( SW_SHOW );
				m_DopplerUpCtrl.ShowWindow( SW_SHOW );
				m_DopplerDnCtrl.ShowWindow( SW_SHOW );
				pWnd->ShowWindow( SW_SHOW);	
				break;
			case RIGCTRL_MODE_PROPORTIONAL:
				m_DopplerCorrCtrl.ShowWindow( SW_SHOW );
				pWnd->ShowWindow( SW_RESTORE);	
				m_DopplerUpCtrl.ShowWindow( SW_HIDE );
				m_DopplerDnCtrl.ShowWindow( SW_HIDE );
				break;
		}
	}
	else
	{
		m_DopplerCorrCtrl.ShowWindow( SW_HIDE );
		m_DopplerUpCtrl.ShowWindow( SW_HIDE );
		m_DopplerDnCtrl.ShowWindow( SW_HIDE );
		pWnd->ShowWindow( SW_HIDE);	
	}
	fnSetRigCtrlOptions( pDoc->m_ComPort, pDoc->m_RigModeGroup,	pDoc->m_CenterFrequency,
			pDoc->m_USBMode,pDoc->m_PortParams, pDoc->m_StepSize);
	SetDopplerCorrection(0);
}

////////////////////////////////////////////////////////////////////////
//   Called to set the manual frequency shift rate for the doppler correction
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::SetDopplerCorrection(INT value)
{
CAO40RcvDoc* pDoc = GetDocument();
	if( pDoc->m_RigModeGroup == (RIGCTRL_MODE_MANUAL | RIGCTRL_MODE_ACTIVEMASK) )
	{
		CString str;
		m_DopplerCorrection = value;
		m_DopplerCorrection = fnSetManualRate(m_DopplerCorrection);
		str.Format("%+d Hz/S",m_DopplerCorrection);
		m_DopplerCorrCtrl.SetWindowText(str);
	}
}

////////////////////////////////////////////////////////////////////////
//   Called to inc/dec the manual frequency shift rate for the doppler correction
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::ChangeDopplerCorrection(INT value)
{
CAO40RcvDoc* pDoc = GetDocument();
	if( pDoc->m_RigModeGroup == (RIGCTRL_MODE_MANUAL | RIGCTRL_MODE_ACTIVEMASK) )
	{
		CString str;
		m_DopplerCorrection += value;
		m_DopplerCorrection = fnSetManualRate(m_DopplerCorrection);
		str.Format("%+d Hz/S",m_DopplerCorrection);
		m_DopplerCorrCtrl.SetWindowText(str);
	}
}

////////////////////////////////////////////////////////////////////////
//   Called from mainframe when F12 key is pressed
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::ExtStartStop()
{
	OnStartstop();
}
////////////////////////////////////////////////////////////////////////
//   Called from mainfrm when left arrow key is pressed
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::ExtLeftKey()
{
	ChangeDopplerCorrection(-1);
	OnLeftbutton();
}
////////////////////////////////////////////////////////////////////////
//   Called from mainfrm when right arrow key is pressed
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::ExtRightKey()
{
	ChangeDopplerCorrection(1);
	OnRightbutton();
}

////////////////////////////////////////////////////////////////////////
//  Called when user presses a function key to change tab views
////////////////////////////////////////////////////////////////////////
void CAO40RcvView::SetTABExternal(INT tab)
{
CAO40RcvDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	if(m_LastTab == tab)
		return;
	m_TabCtrl.SetCurSel(tab);
	pDoc->m_PlotType = tab;
	if(pDoc->m_PlotType != TAB_SIG_VIEW0)
	{
		m_DispFreeze = TRUE;
		m_RxTextCtrl.ClearAll();
		m_RxTextCtrl.SetText( pDoc->GetOutputText() );
		m_RxTextCtrl.EnableWindow(TRUE);
	}
	else
	{
		m_RxTextCtrl.ClearAll();
		m_RxTextCtrl.EnableWindow(FALSE);
		m_DispFreeze = FALSE;
	}
	Invalidate();
	m_LastTab = pDoc->m_PlotType;
}

void CAO40RcvView::OnDeltaposBitadjspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
CAO40RcvDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	pDoc->m_BitAdjust = pDoc->m_BitAdjust - pNMUpDown->iDelta;
	if(pDoc->m_BitAdjust>150)
		pDoc->m_BitAdjust = 150;
	if(pDoc->m_BitAdjust< -150)
		pDoc->m_BitAdjust = -150;
	m_Str.Format("%d",pDoc->m_BitAdjust);
	m_BitAdjTxtCtrl.SetWindowText(m_Str);
	fnSetBitAdj(pDoc->m_BitAdjust);
	*pResult = 0;
}

void CAO40RcvView::OnZerosnrbutton() 
{
CAO40RcvDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	pDoc->m_SNRFilterFactor = (int)fnZeroSNR( -1.0);
}

void CAO40RcvView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if( m_pCPlotData->CurInFreqPlot(point) )
	{
		CString str;
		INT freq = m_pCPlotData->GetCursFreq( point );
		str.Format("%d Hz", freq );
		m_CurFreqTxtCtrl.SetWindowText( str);
	}
	else
	{
		m_CurFreqTxtCtrl.SetWindowText( "" );
	}
	
	CResizableFormView::OnMouseMove(nFlags, point);
}
