// IOCntrl.h: interface for the CIOCntrl class.
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////
//

#if !defined(AFX_IOCNTRL_H__ED8BF853_5C8C_11D3_A248_00A0C996E7F5__INCLUDED_)
#define AFX_IOCNTRL_H__ED8BF853_5C8C_11D3_A248_00A0C996E7F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"
#include "Sound.h"
#include "Wave.h"
#include "fft.h"
#include "bpsk400.h"
#include "bpskdet.h"
#include "rigcntrl.h"



class CIOCntrl  
{
public:
//Methods
	CIOCntrl();
	virtual ~CIOCntrl();

	INT StartIO(HWND h_Wnd, BOOL UseInWave, BOOL UseOutWave, BOOL UseAFC);
	void StopIO();
	void ResetRigCtrl();
	void GetErrorMsg( CString& err){ err = m_ErrorMessage;};
	void SetFFTParams(INT ave, double gain, INT type );
	BOOL GetFFTData(LONG* pData, LONG start, LONG end);
	INT SetInFilePath(CString sPath, long* FileSize, INT Offset);
	INT SetOutWavePath(CString sPath, BOOL AppendMode);

	void ProcessLoop();
//Publicly exposed Variables
	BOOL m_WaveOutPaused;
	BOOL m_UseAFC;
	BOOL InitSystem();
	INT m_CardNum;
	long m_DLLRevision;
	CBPSKDet* m_pBpskdet;
	CRigCntrl m_RigCntrl;

private:
//Functions
	void StatusChange(INT code);
	void DeleteResources();
	void StopThread( );
	void ProcessError( INT ErrorCode );

//Variables
	BOOL m_AppendMode;
	BOOL m_UseInWave;
	BOOL m_fProcThreadQuit;			// signal to thread to quit
	BOOL m_ThreadActive;
	BOOL m_BufferRdy;
	BOOL m_UseOutWave;
	INT m_WaveInOffset;
	INT m_ProgressCount;
	INT m_Progress;
	INT m_OutFileLimit;
	INT m_LastRcvState;
	INT m_DLLStatus;
	INT m_DLLErrStatus;
	ULONG m_FileSize;
	CString m_ErrorMessage;
	CString m_sInFilePath;
	CString m_sOutFilePath;
	CWave WaveDev;
	double* m_pBuffer;
	CWinThread* m_pProcThread;
	CSound* m_pSoundDev;
	Cfft* m_pCfft;
	HWND m_hWnd;
	WAVEFORMATEX m_WaveFormatEx;
	CRITICAL_SECTION m_CriticalSection;	//for keeping threads from stomping on each other

};

#endif // !defined(AFX_IOCNTRL_H__ED8BF853_5C8C_11D3_A248_00A0C996E7F5__INCLUDED_)
