// DispDlg.cpp : implementation file
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AO40Rcv.h"
#include "DispDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDispDlg dialog


CDispDlg::CDispDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDispDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDispDlg)
	m_RawLogOn = FALSE;
	m_TlmLogOn = FALSE;
	m_NetOn = FALSE;
	m_UseABlocks = FALSE;
	m_UseEBlocks = FALSE;
	m_QualifyCRC = FALSE;
	m_NetSocket = 0;
	m_CallSign = _T("");
	m_UseWaveOut = FALSE;
	m_UseTimeStamp = FALSE;
	m_AutoViewToggle = FALSE;
	m_SockDataFormat = 0;
	m_WaveAppend = FALSE;
	//}}AFX_DATA_INIT
	m_OutWavePath = "c:\\Output Wave File Not Selected";
	m_TelemPath = "c:\\";
}


void CDispDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDispDlg)
	DDX_Control(pDX, IDC_USETIMESTAMP, m_UseTimeStampCtrl);
	DDX_Control(pDX, IDC_WAVEAPPEND, m_WaveAppendCtrl);
	DDX_Control(pDX, IDC_TELMPATH, m_TelmPathCtrl);
	DDX_Control(pDX, IDC_OUTWAVENAME, m_OutWaveNameCtrl);
	DDX_Control(pDX, IDC_TIMEAVAIL, m_TimeAvailCtrl);
	DDX_Check(pDX, IDC_RAWLOG, m_RawLogOn);
	DDX_Check(pDX, IDC_TLMLOG, m_TlmLogOn);
	DDX_Check(pDX, IDC_NETWORK_ON, m_NetOn);
	DDX_Check(pDX, IDC_USEABLOCKS, m_UseABlocks);
	DDX_Check(pDX, IDC_USEEBLOCKS, m_UseEBlocks);
	DDX_Check(pDX, IDC_USECRC, m_QualifyCRC);
	DDX_Text(pDX, IDC_SOCKET, m_NetSocket);
	DDX_Text(pDX, IDC_CALLSIGNEDIT, m_CallSign);
	DDV_MaxChars(pDX, m_CallSign, 20);
	DDX_Check(pDX, IDC_USEWAVOUT, m_UseWaveOut);
	DDX_Check(pDX, IDC_USETIMESTAMP, m_UseTimeStamp);
	DDX_Check(pDX, IDC_AUTOTOGGLE, m_AutoViewToggle);
	DDX_Radio(pDX, IDC_P3TSYNC, m_SockDataFormat);
	DDX_Check(pDX, IDC_WAVEAPPEND, m_WaveAppend);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDispDlg, CDialog)
	//{{AFX_MSG_MAP(CDispDlg)
	ON_BN_CLICKED(IDC_BKCOLOR, OnBkcolor)
	ON_BN_CLICKED(IDC_SELFONT, OnSelfont)
	ON_BN_CLICKED(IDC_SELOUTWAVE, OnSeloutwave)
	ON_BN_CLICKED(IDC_SELFOLDER, OnSelfolder)
	ON_BN_CLICKED(IDC_WAVEAPPEND, OnWaveappend)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDispDlg message handlers

void CDispDlg::OnBkcolor() 
{
CColorDialog dlgColor(m_crRcvBackColor, CC_RGBINIT);
	if (dlgColor.DoModal() == IDOK)
	{
		m_crRcvBackColor = dlgColor.GetColor();
	}	
}

void CDispDlg::OnSelfont() 
{
	CClientDC dc(NULL);
LOGFONT lf = m_lfRcvFont;
	lf.lfHeight = -::MulDiv(-lf.lfHeight, dc.GetDeviceCaps(LOGPIXELSY), 72);
	CFontDialog dlg(&lf);
	dlg.m_cf.rgbColors = m_crRcvTextColor;
	if (dlg.DoModal() == IDOK)
	{
		m_crRcvTextColor = dlg.GetColor();
		lf.lfHeight = -::MulDiv(-lf.lfHeight, 72, dc.GetDeviceCaps(LOGPIXELSY));
		m_lfRcvFont = lf;
	}	
}

BOOL CDispDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	if( (m_SockDataFormat >= 2) ||
		(m_SockDataFormat < 0) )
		m_SockDataFormat = 0;

	m_OutWaveNameCtrl.SetWindowText(m_OutWavePath);
	m_TimeAvailCtrl.SetWindowText( 	GetDiskSpaceMinutes( m_OutWavePath ) );
	m_TelmPathCtrl.SetWindowText(m_TelemPath);
	if(m_WaveAppend)
	{
		m_UseTimeStamp = FALSE;
		m_UseTimeStampCtrl.EnableWindow(FALSE);
	}
	else
		m_UseTimeStampCtrl.EnableWindow(TRUE);
	UpdateData(FALSE);	// Put back into controls
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDispDlg::OnOK() 
{
	CDialog::OnOK();
}

void CDispDlg::OnSeloutwave() 
{
//  handler code here for getting wave Input filename
CString sFilter = "Wave Files (*.wav)|*.wav||";
CFileDialog Dlgfile( TRUE, "wav", m_OutWavePath, 
			OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
			(LPCTSTR)sFilter, this );
	if( Dlgfile.DoModal() == IDOK)
	{
		m_OutWavePath = Dlgfile.GetPathName();
		m_TimeAvailCtrl.SetWindowText( 	GetDiskSpaceMinutes( m_OutWavePath ) );
		m_OutWaveNameCtrl.SetWindowText(m_OutWavePath);
	}
}

CString CDispDlg::GetDiskSpaceMinutes(CString sPath)
{
CString str;
	LONGLONG size = GetDriveFreeSpace( &sPath);
	if( size != 0 )
	{
		size /= (16000*60);
		str.Format(" %d Minutes Disk Space", size );
	}
	else
		str = _T("");
	return str;	
}
/////////////////////////////////////////////////////////////////
// returns free disk space on drive specified by pPathName.
// The extra logic is for dealing with early Win95 versions that don't
// support the extended disk space function "GetDiskFreeSpaceEx(..)".
// Returns zero if can't get the disk info.
/////////////////////////////////////////////////////////////////
LONGLONG CDispDlg::GetDriveFreeSpace(CString* pPathName)
{
typedef BOOL (CALLBACK* LPFNDLLFUNC)(LPCTSTR, PULARGE_INTEGER,
					 PULARGE_INTEGER, PULARGE_INTEGER);

LONGLONG SpaceFree;
INT ret;
	SpaceFree = 0;					// see if it exists
	HMODULE hKernel = GetModuleHandle( _T("kernel32.dll"));
	LPFNDLLFUNC pFunct = (LPFNDLLFUNC)GetProcAddress( hKernel,"GetDiskFreeSpaceExA");
	if(pFunct != NULL)		//if function is in kernel32.dll
	{
		ULARGE_INTEGER TotalSpace;
		ULARGE_INTEGER FreeSpace;
		ret = pFunct( pPathName->Left(3), &FreeSpace, &TotalSpace, NULL);
		if(ret!=0)
			SpaceFree = FreeSpace.QuadPart;
		else
			SpaceFree = 0;
	}
	else					//else is Win95 pre OSR2 so use old function
	{
		DWORD SectorsPerCluster, BytesPerSector;
		DWORD NumberOfFreeClusters, TotalNumberOfClusters;
		if( GetDiskFreeSpace( pPathName->Left(3),
					&SectorsPerCluster, &BytesPerSector,
					&NumberOfFreeClusters, &TotalNumberOfClusters ) ) 
			SpaceFree = (LONGLONG)(NumberOfFreeClusters*SectorsPerCluster*BytesPerSector);
		else
			SpaceFree = 0;
	}
	return SpaceFree;
}

void CDispDlg::OnSelfolder() 
{
CString str;
	str = m_TelemPath+"filename";
static char BASED_CODE szFilter[] = "Telemetry Files (*.tlm and *.raw)|*.*||";
CFileDialog Dlgfile( FALSE, NULL,str, OFN_HIDEREADONLY|OFN_PATHMUSTEXIST|OFN_NOCHANGEDIR,
							(LPCTSTR)szFilter, this );
	Dlgfile.m_ofn.lpstrTitle = _T("Select Telemetry Data Folder");
	if( Dlgfile.DoModal() == IDOK)
	{
		str = Dlgfile.GetFileName();
		m_TelemPath = Dlgfile.GetPathName();
		m_TelemPath.Replace(str,"");
	}
	m_TelmPathCtrl.SetWindowText(m_TelemPath);
}


void CDispDlg::OnWaveappend() 
{
	UpdateData(TRUE);	// latest state from control
	if(m_WaveAppend)
	{
		m_UseTimeStamp = FALSE;
		m_UseTimeStampCtrl.EnableWindow(FALSE);
	}
	else
		m_UseTimeStampCtrl.EnableWindow(TRUE);
	UpdateData(FALSE);	// Put back into controls
}
