// RigDlg.cpp : implementation file
//
//////////////////////////////////////////////////////////////////////
// Copyright 2000.    Moe Wheatley AE4JY  <ae4jy@qsl.net>
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "AO40Rcv.h"
#include "RigDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRigDlg dialog


CRigDlg::CRigDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRigDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRigDlg)
	m_ComPort = 0;
	m_RigModeGroup = 0;
	m_USBMode = FALSE;
	m_BitRate = 3;
	m_NumBits = 1;
	m_DNString = _T("");
	m_UPString = _T("");
	m_UseRTSDTR = 0;
	m_Parity = 0;
	m_StepSize = 100;
	//}}AFX_DATA_INIT
}


void CRigDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRigDlg)
	DDX_Control(pDX, IDC_STEPSIZE, m_StepSizeCtrl);
	DDX_Control(pDX, IDC_CENTERFREQ, m_CenterFreqCtrl);
	DDX_Radio(pDX, IDC_PTTNONE, m_ComPort);
	DDX_Radio(pDX, IDC_MANUALMODE, m_RigModeGroup);
	DDX_Check(pDX, IDC_USBMODE, m_USBMode);
	DDX_Radio(pDX, IDC_B1200, m_BitRate);
	DDX_Radio(pDX, IDC_BITS7, m_NumBits);
	DDX_Text(pDX, IDC_DNEDIT, m_DNString);
	DDX_Text(pDX, IDC_UPEDIT, m_UPString);
	DDX_Radio(pDX, IDC_USERTSDTR, m_UseRTSDTR);
	DDX_Radio(pDX, IDC_PNONE, m_Parity);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRigDlg, CDialog)
	//{{AFX_MSG_MAP(CRigDlg)
	ON_NOTIFY(UDN_DELTAPOS, IDC_CENTERSPIN, OnDeltaposCenterspin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STEPSIZESPIN, OnDeltaposStepsizespin)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRigDlg message handlers

BOOL CRigDlg::OnInitDialog() 
{
CString str;
INT IDC_Array[] = 
		{IDC_PTTNONE,IDC_PTTCOM1,IDC_PTTCOM2,IDC_PTTCOM3,IDC_PTTCOM4,
		IDC_PTTCOM5,IDC_PTTCOM6,IDC_PTTCOM7,IDC_PTTCOM8};
	CDialog::OnInitDialog();
CWnd* pWnd;
	for(INT i=0; i<=8; i++)
	{
		pWnd = GetDlgItem( IDC_Array[i] );
		if( fnCheckComPort(i) )
		{
			pWnd->EnableWindow(TRUE);
			if( m_ComPort == i )
			{
				pWnd->CheckDlgButton( IDC_Array[i], TRUE );
			}
		}
		else
		{
			pWnd->EnableWindow(FALSE);
		}
	}
	str.Format("%d",m_CenterFrequency);
	m_CenterFreqCtrl.SetWindowText(str);
	str.Format("%d",m_StepSize);
	m_StepSizeCtrl.SetWindowText(str);
// UnPack serial port setup group controls from one 32 bit word
	m_NumBits = m_PortParams&0x000000FF;
	m_Parity = (m_PortParams&0x0000FF00) >> 8;
	m_BitRate = (m_PortParams&0x00FF0000) >> 16;
	m_UseRTSDTR = (m_PortParams&0xFF000000) >> 24;	//0==use RTSDTR
	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CRigDlg::OnOK() 
{
	UpdateData(TRUE);
// Pack serial port setup group controls into one big ass 32 bit word
	m_PortParams = m_NumBits;			//0==7, 1==8bits
	m_PortParams |= (m_Parity<<8);		//0==none,1==Even,2==Odd
	m_PortParams |= (m_BitRate<<16);	//0==1200....7==57600
	m_PortParams |= (m_UseRTSDTR<<24);	//1=cmds, 0=use RTSDTRpulses
	CDialog::OnOK();
}

void CRigDlg::OnDeltaposCenterspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
CString str;
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	m_CenterFrequency	= m_CenterFrequency - (10*pNMUpDown->iDelta);
	if(m_CenterFrequency > 2500)
		m_CenterFrequency = 2500;
	if(m_CenterFrequency < 800)
		m_CenterFrequency = 800;
	str.Format("%d",m_CenterFrequency);
	m_CenterFreqCtrl.SetWindowText(str);
	
	*pResult = 0;
}


void CRigDlg::OnDeltaposStepsizespin(NMHDR* pNMHDR, LRESULT* pResult) 
{
CString str;
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	m_StepSize	= m_StepSize - (10*pNMUpDown->iDelta);
	if(m_StepSize > 100)
		m_StepSize = 100;
	if(m_StepSize < 10)
		m_StepSize = 10;
	str.Format("%d",m_StepSize);
	m_StepSizeCtrl.SetWindowText(str);
	
	*pResult = 0;
}
