// StatusCntrl.cpp : implementation file
//

#include "stdafx.h"
#include "FWrite2.h"
#include "StatusCntrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStatusCntrl

CStatusCntrl::CStatusCntrl()
{
	m_nPos = 0;
	m_nLower = 0;
	m_nUpper = 100;
	m_BkColor = RGB( 192,192,192);
	m_TxtColor = RGB( 0,0,0);
	m_BarColor = RGB( 0,255,255);
	m_LEDColor = RGB( 128,128,128);
}

CStatusCntrl::~CStatusCntrl()
{
}


BEGIN_MESSAGE_MAP(CStatusCntrl, CWnd)
	//{{AFX_MSG_MAP(CStatusCntrl)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CStatusCntrl::Create(LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect,
							CWnd* pParentWnd, UINT nID)
{
	static CString className = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW);
	return CWnd::CreateEx(WS_EX_CLIENTEDGE | WS_EX_STATICEDGE,
							className, lpszWindowName, dwStyle,
							rect.left,rect.top,rect.right-rect.left,rect.bottom-rect.top,
							pParentWnd->GetSafeHwnd(), (HMENU)nID);
}

void CStatusCntrl::SetRange(UINT nLower, UINT nUpper)
{
	ASSERT( nLower>=0 && nLower <= 0xFFFF );
	ASSERT( nUpper>=nLower && nUpper <= 0xFFFF );
	m_nLower = nLower;
	m_nUpper = nUpper;
}

UINT CStatusCntrl::SetPos(UINT nPos)
{
	ASSERT( nPos >= m_nLower && nPos<=m_nUpper);
	UINT nOld = m_nPos;
	m_nPos = nPos;
	InvalidateCntrl();
	return nOld;
}

void CStatusCntrl::SetBarColor(COLORREF cr)
{
	m_BarColor = cr;
	InvalidateCntrl();
}
void CStatusCntrl::SetBkColor(COLORREF cr)
{
	m_BkColor = cr;
	InvalidateCntrl();
}
void CStatusCntrl::SetTxtColor(COLORREF cr)
{
	m_TxtColor = cr;
	InvalidateCntrl();
}
void CStatusCntrl::SetLEDColor(COLORREF cr)
{
	m_LEDColor = cr;
	InvalidateCntrl();
}

void CStatusCntrl::InvalidateCntrl()
{
	CRect r;
	GetClientRect(r);
	InvalidateRect(r);
}

/////////////////////////////////////////////////////////////////////////////
// CStatusCntrl message handlers

void CStatusCntrl::OnPaint() 
{
CDC MemDC;
CRect rClient;
CRect rLED;
CRect rLEDBlock;
CRect rProg;
CPaintDC dc(this); // device context for painting
//create various rectangles for all the viewable thingys
	GetClientRect( rClient );	
	rLEDBlock.SetRect(rClient.right-rClient.Height(),rClient.top,rClient.right,rClient.bottom);
	rProg.SetRect( rClient.left,rClient.top,rClient.right-rClient.Height(),rClient.bottom);
	rLED.SetRect(rLEDBlock.left+3,rLEDBlock.top+3,rLEDBlock.right-3,rLEDBlock.bottom-3);

	if( m_bmImage.m_hObject != NULL )	// delete old bitmap object
		m_bmImage.DeleteObject();
//create a new bitmap with current screen DC settings
	m_bmImage.CreateCompatibleBitmap(&dc,rClient.Width(),rClient.Height() );
//create memory DC pointer to the image bitmap
	MemDC.CreateCompatibleDC( &dc);
	CBitmap* pbmOld = MemDC.SelectObject( &m_bmImage );

//Create 2 rectangles for the progress bar depending upon m_nPos. 	
	UINT nRange = m_nUpper - m_nLower;
	CRect rLeft = rProg;
	CRect rRight = rProg;
	rLeft.right = (rProg.Width()*(m_nPos-m_nLower))/nRange;
	rRight.left = rLeft.right;

//Create two corresponding regions for use in clipping the text areas
	CRgn rgnLeft,rgnRight,rgnLED;
	rgnLeft.CreateRectRgnIndirect(rLeft);
	rgnRight.CreateRectRgnIndirect(rRight);
	rgnLED.CreateEllipticRgnIndirect(rLED);

//Fill Progress bar with bar color
	MemDC.FillSolidRect(rLeft,m_BarColor);
//Fill non Progress bar with background color
	MemDC.FillSolidRect(rRight,m_BkColor);
//Fill round LED area with color and the background black
	MemDC.FillSolidRect(rLEDBlock,RGB(0,0,0));
	MemDC.SelectClipRgn(&rgnLED);
	MemDC.FillSolidRect(rLED,m_LEDColor);

//Get status bar text to place in the window
	CString strCaption;
	GetWindowText(strCaption);

//Draw with normal text color the part NOT under the progress bar
	MemDC.SelectClipRgn(&rgnRight);
	MemDC.SetBkMode(TRANSPARENT);
	MemDC.SetTextColor( m_TxtColor );
	MemDC.DrawText(strCaption, rProg,DT_VCENTER|DT_SINGLELINE|DT_CENTER);

//Draw with backgrnd color the part under the progress bar
	MemDC.SelectClipRgn(&rgnLeft);
	MemDC.SetTextColor( GetSysColor(COLOR_BACKGROUND) );
	MemDC.DrawText(strCaption, rProg,DT_VCENTER|DT_SINGLELINE|DT_CENTER);
// Copy bitmap into screen context
	dc.BitBlt(	rClient.left, rClient.top,		//dest left,top
				rClient.right,	rClient.bottom,	//dest width, Height
				&MemDC,							//src dc
				0,0,							//src left, top
				SRCCOPY);
//deselect bitmap
	MemDC.SelectObject( pbmOld );	// from DC
}



